stages:
 - build
 - deploy
 
docker-build:
  # Official docker image.
  image: docker:latest
  stage: build
  services:
    - docker:dind
  before_script:
    # Login to Google Container Registry
    - base64 -d $GCP_SA_KEY | docker login -u _json_key --password-stdin https://gcr.io
    # Login to Gitlab container Registry
    - echo $CI_JOB_TOKEN | docker login -u gitlab-ci-token $CI_REGISTRY --password-stdin
  script:
    # Build and tag image for both GCR and Gitlab registries
    - docker build  -t gcr.io/$PROJECT_ID/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME:latest .
    # Push image to GCR
    - docker push gcr.io/$PROJECT_ID/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME:latest
    # Push image to Gitlab registry
    #- docker push $CI_REGISTRY_IMAGE:latest
  only:
    - master
  
deploy-gke:
  image: dwdraju/alpine-gcloud
  when: manual
  stage: deploy
  script:
    - base64 -d  $GCP_SA_KEY > ${HOME}/gcloud-service-key.json
    - gcloud auth activate-service-account --key-file=${HOME}/gcloud-service-key.json
    - gcloud container clusters get-credentials retya-cluster --region us-east1 --project $PROJECT_ID
    - gcloud components install kubectl
    - kubectl apply -f simple-web.yaml
  only:
    - master


